\name{summary.DSA}
\alias{summary.DSA}
\title{Summarization of the results of a call to the DSA routine}
\description{
  Provides a useful summary of a call to the DSA routine.
}
\usage{
summary.DSA(object, ...)
}


\arguments{
  \item{object}{an object of class 'DSA'.}
  \item{\dots}{currently ignored.}
}

\value{An object of class 'summary.DSA'. Objects of class 'summary.DSA'
  have the following attributes:
  \item{model}{a formula representing the final model selected
    by the DSA routine.}
  \item{family}{a description of the link function for \code{model.selected}: \code{gaussian} indicates
    the indentity function while \code{binomial} indicates  the logit function.}
  \item{n.obs}{number of observations in the data frame \code{data} passed in to the DSA routine.}
  \item{n.nonna}{number of complete observations on which \code{model.selected}
    is based (no missing values).}
  \item{average.CVrisks.best}{minimum average cross-validated risk among
    all average cross-validated risks
    associated with all model sizes and interaction orders considered by
  the DSA routine.}
  \item{average.CVrisk.model.selected}{average cross-validated risk
    for \code{model.selected}.}
  \item{coefficients}{the coefficients of \code{model.selected} fitted on
    \code{n.nonna} observations from the
    learning set.}
  \item{n.id}{number of independent experimental units in the data frame
    \code{data} passed in to the DSA routine.}
  \item{n.id.nonna}{number of complete independent experimental units on which \code{model.selected}
    is based (no missing values).}

}
\author{
  James Bullard.
}
\seealso{
  \code{\link{DSA}}.
}
\examples{
library(DSA)

## an example using the state census data. (gaussian)  
data(state)
state.data <- as.data.frame(state.x77)
colnames(state.data) <- unlist(lapply(strsplit(colnames(state.data), " "),
                                      function(x) paste(x, collapse = "")))
res <- DSA(Murder ~ 1, data = state.data, maxsize = 5, maxsumofpow = 2,maxorderint = 2)
res
summary(res)
}

\keyword{models}

