#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <float.h>
#include <time.h>

#include <R.h>
#include <R_ext/Utils.h>
#include <Rmath.h>

#include "dsa.h"
#include "dsa_model.h"

/* ------------------------------------------------------------------------
   Substitution Moves on Learning Set
   ------------------------------------------------------------------------ */

int DSA_PACK_Sstep(int *gCOUNT,int *gCONST,double *bestarss,int **bestmodels,int *tempmodel,
		   int *currentmodel,int *nextmodel,int *newterm,double *Xdata,double *tempXdata,
		   double *Ydata,double *tempYdata,double *tempterm,int *sx,double *glmWT,double *PARA,
		   double *SE,double *COV, double *RES,int *ithterm,
		   double *WTdata,int trainFlag,double *currentarss,int nforced,
		   double* new_coefficients,
		   double* WX, double* Z, double* qraux, double* effects, double* work, int* pivot,double *binWTdata)
{
  int IP,msize,samplesize,nvarX,maxsize,nfolds,maxsumofpow,orderint,i,j,pl,newtermindex;
  int jthvar,nglmcall,orderint_in_newterm,sumofpow_in_newterm,CENSOR,is_newterm_unique,binind;
  double oldrss,newrss;

  /* Initialization */  
  IP = gCOUNT[0]+1;
  msize = gCOUNT[0];
  nglmcall = gCOUNT[2];

  maxsize = gCONST[0];
  maxsumofpow = gCONST[2];
  nfolds = gCONST[3];
  nvarX = gCONST[5];
  CENSOR = gCONST[6];
  binind = gCONST[9];
  if(trainFlag == 1)
    {
      samplesize = gCOUNT[4];
      orderint = gCOUNT[1];
    }
  else 
    {
      samplesize = gCONST[4];
      orderint = gCONST[8];
    }
  oldrss = currentarss[IP-1];
  newrss = currentarss[IP-1];

  /* Start all the sub moves and swap moves */
  for(newtermindex=nforced;newtermindex<msize;newtermindex++)for(jthvar=0;jthvar<nvarX;jthvar++)
    {
      if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\nSUB/SWAP on term %li with var %li",newtermindex,jthvar);
      for(i=0;i<maxsize;i++)for(j=0;j<nvarX;j++)tempmodel[j*maxsize+i] = currentmodel[j*maxsize+i];
      for(j=0;j<nvarX;j++)newterm[j] = tempmodel[j*maxsize+newtermindex];

      /* TRY ADDING ONE TO P-VECTOR */
      if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\tTry to add 1 to var %li",jthvar);
      newterm[jthvar] = newterm[jthvar] + 1;

      DSA_PACK_checknewterm(&orderint_in_newterm,&sumofpow_in_newterm,&is_newterm_unique,newterm,nvarX,
			    tempmodel,ithterm,maxsize,newtermindex,0);
      /* Test if submove accepted */
      if(is_newterm_unique == 1 && sumofpow_in_newterm <= maxsumofpow && orderint_in_newterm <= orderint)
	{
	  if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\tadd 1 accepted");

	

	  DSA_PACK_evaluatenewmodel(sx,maxsize,msize,tempmodel,newtermindex,newterm,nvarX,samplesize,
				    tempXdata,Xdata,tempterm,CENSOR,glmWT,WTdata,IP,tempYdata,Ydata,PARA,
				    SE,COV,RES,&nglmcall,&newrss,nextmodel,0,binind,
				    new_coefficients, WX, Z, qraux, effects, work, pivot,binWTdata);
	}
      else
	{
	  if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\tadd 1 rejected");
	  /* Test if swap moves allowed and possible */
	  if(is_newterm_unique == 1 && orderint_in_newterm > orderint)
	    {
	      if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\t\tTry Swap moves");
	      /* TRY ALTERNATE-SUB MOVES */
	      for(pl=0;pl<nvarX;pl++)
		{
		  if(newterm[pl] != 0)
		    {
		      i=newterm[pl];
		      newterm[pl] = 0;
		      DSA_PACK_checknewterm(&orderint_in_newterm,&sumofpow_in_newterm,&is_newterm_unique,
					    newterm,nvarX,tempmodel,ithterm,maxsize,newtermindex,0);

		      /*Test if swap move accepted */
		      if(is_newterm_unique == 1 && sumofpow_in_newterm <= maxsumofpow && orderint_in_newterm <= orderint)
			{
			  if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\t\tSubswap accepted");
			  DSA_PACK_evaluatenewmodel(sx,maxsize,msize,tempmodel,newtermindex,newterm,nvarX,
						    samplesize,tempXdata,Xdata,tempterm,CENSOR,glmWT,WTdata,IP,
						    tempYdata,Ydata,PARA,SE,COV,RES,&nglmcall,&newrss,
						    nextmodel,0,binind,
						    new_coefficients, WX, Z, qraux, effects, work, pivot,binWTdata);
			}
		      else
			{
			  if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\t\tSubswap rejected");
			}
		      newterm[pl] = i;
		    }
		}
	    }
	} /* end of else do swaps */
      if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\tTry to subs 1 to var %li",jthvar);
      for(i=0;i<maxsize;i++)for(j=0;j<nvarX;j++)tempmodel[j*maxsize+i] = currentmodel[j*maxsize+i];
      for(j=0;j<nvarX;j++)newterm[j] = tempmodel[j*maxsize+newtermindex];

      /* TRY SUBTRACTING ONE TO P-VECTOR */
      if(newterm[jthvar] > 0)
	{
	  if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\tPossible to subs");
	  newterm[jthvar] = newterm[jthvar] - 1;
	  DSA_PACK_checknewterm(&orderint_in_newterm,&sumofpow_in_newterm,&is_newterm_unique,newterm,
				nvarX,tempmodel,ithterm,maxsize,newtermindex,0);

	  /* Test if submove accepted */
	  if(is_newterm_unique == 1 && sumofpow_in_newterm <= maxsumofpow && 
	     orderint_in_newterm <= orderint && orderint_in_newterm>=1)
	    {
	      if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\tsubs 1 accepted");
	      DSA_PACK_evaluatenewmodel(sx,maxsize,msize,tempmodel,newtermindex,newterm,nvarX,samplesize,
					tempXdata,Xdata,tempterm,CENSOR,glmWT,WTdata,IP,tempYdata,Ydata,
					PARA,SE,COV,RES,&nglmcall,&newrss,nextmodel,0,binind,
					new_coefficients, WX, Z, qraux, effects, work, pivot,binWTdata);
	    }
	  else
	    {
	      if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)Rprintf("\n\tsubs 1 rejected");
	    }
	}
    }   /* loops over i-th term and jth variable  */

  return(DSA_PACK_exportresult(&oldrss,newrss,msize,nvarX,currentmodel,nextmodel,maxsize,bestarss,
			       gCOUNT,IP,nglmcall,bestmodels,0,currentarss));
}       


/* ------------------------------------------------------------------------
   Addition Moves on Learning Set
   ------------------------------------------------------------------------ */

int DSA_PACK_Astep(int *gCOUNT,int *gCONST,double *bestarss,int **bestmodels,int *tempmodel,int *currentmodel,
		   int *nextmodel,int *newterm,double *Xdata,double *tempXdata,double *Ydata,double *tempYdata,
		   double *tempterm,int *sx,double *glmWT,double *PARA,double *SE,double *COV,
		   double *RES,int *ithterm,double *WTdata,int trainFlag,double *currentarss,
		   double* new_coefficients,
		   double* WX, double* Z, double* qraux, double* effects, double* work, int* pivot,double *binWTdata)
{
  int IP,msize,nvarX,maxsize,nfolds,maxsumofpow,orderint,i,j,pl,newtermindex,jthvar,samplesize,nglmcall,CENSOR,orderint_in_newterm,sumofpow_in_newterm,is_newterm_unique,binind;
  double oldrss,newrss;

  /* Initialization */  
  IP = gCOUNT[0]+1;
  msize = gCOUNT[0];
  nglmcall = gCOUNT[2];

  maxsize = gCONST[0];
  maxsumofpow = gCONST[2];
  nfolds = gCONST[3];
  nvarX = gCONST[5];
  CENSOR = gCONST[6];
  binind = gCONST[9];
  if(trainFlag == 1)
    {
      samplesize = gCOUNT[4];
      orderint = gCOUNT[1];
    }
  else 
    {
      samplesize = gCONST[4];
      orderint = gCONST[8];
    }
  oldrss = R_PosInf;
  newrss = R_PosInf;

  /* Start all the addsub moves and addswap moves */
  for(newtermindex=0;newtermindex<msize;newtermindex++)for(jthvar=0;jthvar<nvarX;jthvar++)
    {
      for(i=0;i<maxsize;i++)for(j=0;j<nvarX;j++)tempmodel[j*maxsize+i] = currentmodel[j*maxsize+i];
      for(j=0;j<nvarX;j++)newterm[j] = tempmodel[j*maxsize+newtermindex];

      /* TRY ADDING ONE TO P-VECTOR */
      newterm[jthvar] = newterm[jthvar] + 1;
      DSA_PACK_checknewterm(&orderint_in_newterm,&sumofpow_in_newterm,&is_newterm_unique,newterm,
			    nvarX,tempmodel,ithterm,maxsize,newtermindex,1);

      /* Test if addsub move accepted */
      if(is_newterm_unique == 1 && sumofpow_in_newterm <= maxsumofpow && orderint_in_newterm <= orderint)
	{
	  msize++;
	  IP++;
	  DSA_PACK_evaluatenewmodel(sx,maxsize,msize,tempmodel,msize-1,newterm,nvarX,samplesize,tempXdata,
				    Xdata,tempterm,CENSOR,glmWT,WTdata,IP,tempYdata,Ydata,PARA,SE,COV,RES,
				    &nglmcall,&newrss,nextmodel,0,binind,
				    new_coefficients, WX, Z, qraux, effects, work, pivot,binWTdata);
	  IP--;
	  msize--;
	} 
      else
	{
	  /* Test if swap moves allowed and possible */
	  if(is_newterm_unique == 1 && orderint_in_newterm > orderint)
	    {
	      /* TRY ALTERNATE-SUBADD MOVES */
	      for(pl=0;pl<nvarX;pl++)
		{
		  if(newterm[pl] != 0)
		    {
		      i=newterm[pl];
		      newterm[pl] = 0;
		      DSA_PACK_checknewterm(&orderint_in_newterm,&sumofpow_in_newterm,&is_newterm_unique,
					    newterm,nvarX,tempmodel,ithterm,maxsize,newtermindex,1);
		      /*Test if addswap move accepted */
		      if(is_newterm_unique == 1 && sumofpow_in_newterm <= maxsumofpow && orderint_in_newterm <= orderint)
			{
			  msize++;
			  IP++;
			  DSA_PACK_evaluatenewmodel(sx,maxsize,msize,tempmodel,msize-1,newterm,nvarX,
						    samplesize,tempXdata,Xdata,tempterm,CENSOR,glmWT,WTdata,
						    IP,tempYdata,Ydata,PARA,SE,COV,RES,&nglmcall,
						    &newrss,nextmodel,0,binind,
						    new_coefficients, WX, Z, qraux, effects, work, pivot,binWTdata
						    );
			  IP--;
			  msize--;
			}
		      newterm[pl] = i;
		    }
		}
	    }
	} /* end of else do swaps */

      for(i=0;i<maxsize;i++)for(j=0;j<nvarX;j++)tempmodel[j*maxsize+i] = currentmodel[j*maxsize+i];
      for(j=0;j<nvarX;j++)newterm[j] = tempmodel[j*maxsize+newtermindex];

      /* TRY SUBTRACTING ONE TO P-VECTOR */
      if(newterm[jthvar] > 0)
	{
	  newterm[jthvar] = newterm[jthvar] - 1;
	  DSA_PACK_checknewterm(&orderint_in_newterm,&sumofpow_in_newterm,&is_newterm_unique,
				newterm,nvarX,tempmodel,ithterm,maxsize,newtermindex,1);
	  /* Test if addsub move accepted */
	  if(is_newterm_unique == 1 && sumofpow_in_newterm <= maxsumofpow && orderint_in_newterm <= orderint && 
	     orderint_in_newterm>=1)
	    {
	      msize++;
	      IP++;
	      DSA_PACK_evaluatenewmodel(sx,maxsize,msize,tempmodel,msize-1,newterm,nvarX,samplesize,tempXdata,
					Xdata,tempterm,CENSOR,glmWT,WTdata,IP,tempYdata,Ydata,PARA,SE,COV,RES,
					&nglmcall,&newrss,nextmodel,0,binind,
					new_coefficients, WX, Z, qraux, effects, work, pivot,binWTdata);
	      IP--;
	      msize--;
	    } 
	}
    }   /* loops over i-th term and jth variable */

  /* TRY ADDING A MAIN TERM (UNIT VECTORS) */
  for(jthvar=0;jthvar<nvarX;jthvar++)
    {
      for(i=0;i<maxsize;i++)for(j=0;j<nvarX;j++)tempmodel[j*maxsize+i] = currentmodel[j*maxsize+i];
      DSA_PACK_initialize_l(newterm,nvarX);
      newterm[jthvar] = 1;
      DSA_PACK_checknewterm(&orderint_in_newterm,&sumofpow_in_newterm,&is_newterm_unique,newterm,nvarX,
			    tempmodel,ithterm,maxsize,newtermindex,1);

      /* Test if addmain move accepted */
      if(is_newterm_unique == 1)
	{
	  msize++;
	  IP++;
	  DSA_PACK_evaluatenewmodel(sx,maxsize,msize,tempmodel,msize-1,newterm,nvarX,samplesize,tempXdata,Xdata,
				    tempterm,CENSOR,glmWT,WTdata,IP,tempYdata,Ydata,PARA,SE,COV,RES,
				    &nglmcall,&newrss,nextmodel,0,binind,
				    new_coefficients, WX, Z, qraux, effects, work, pivot,binWTdata);
	  IP--;
	  msize--;
	}
    }

  msize++;
  IP++;
  return(DSA_PACK_exportresult(&oldrss,newrss,msize,nvarX,currentmodel,nextmodel,maxsize,bestarss,gCOUNT,IP,
			       nglmcall,bestmodels,0,currentarss));
}       /* end of addition routine */      


/* ------------------------------------------------------------------------
   Deletion Moves on Learning Set
   ------------------------------------------------------------------------ */

int DSA_PACK_Dstep(int *gCOUNT,int *gCONST,double *bestarss,int **bestmodels,int *tempmodel,int *currentmodel,
		   int *nextmodel,int *newterm,double *Xdata,double *tempXdata,double *Ydata,double *tempYdata,
		   double *tempterm,int *sx,double *glmWT,double *PARA,double *SE,double *COV,
		   double *RES,double *WTdata,int trainFlag,double *currentarss,int nforced,
		   double* new_coefficients,
		   double* WX, double* Z, double* qraux, double* effects, double* work, int* pivot,double *binWTdata
		   )
{
  int IP,msize1,msize2,nvarX,maxsize,nfolds,maxsumofpow,orderint,newtermindex,samplesize,nglmcall,CENSOR,binind;
  double EPSILON,oldrss, newrss;

  /* Initialization */  
  IP = gCOUNT[0]+1;
  msize1 = gCOUNT[0];
  nglmcall = gCOUNT[2];

  maxsize = gCONST[0];
  maxsumofpow = gCONST[2];
  nfolds = gCONST[3];
  nvarX = gCONST[5];
  CENSOR = gCONST[6];
  binind = gCONST[9];
  if(trainFlag == 1)
    {
      samplesize = gCOUNT[4];
      orderint = gCOUNT[1];
    }
  else 
    {
      samplesize = gCONST[4];
      orderint = gCONST[8];
    }

  IP = IP - 1;
  msize2 = msize1 - 1;
  oldrss = bestarss[IP-1];
  newrss = bestarss[IP-1];
  EPSILON = 0.01;

  /* Start all the del moves */
  for(newtermindex=nforced;newtermindex<msize1;newtermindex++)
    {
      DSA_PACK_initialize_l(tempmodel,maxsize*nvarX);
      DSA_PACK_evaluatenewmodel(sx,maxsize,msize2,tempmodel,newtermindex,currentmodel,nvarX,samplesize,
				tempXdata,Xdata,tempterm,CENSOR,glmWT,WTdata,IP,tempYdata,Ydata,PARA,SE,COV,RES,
				&nglmcall,&newrss,nextmodel,1,binind,
				new_coefficients, WX, Z, qraux, effects, work, pivot,binWTdata);
    }
  IP++; /* term not yet deleted */

  if((oldrss-newrss)>epsiloncompare)
    {
      msize1--;
      IP--;
    }
  return(DSA_PACK_exportresult(&oldrss,newrss,msize1,nvarX,currentmodel,nextmodel,maxsize,bestarss,gCOUNT,IP,
			       nglmcall,bestmodels,1,currentarss));
}       /* end of deletion routine */      



void DSA_PACK_gettempXdata(int msize,int *tempmodel, int maxsize, int nvarX, int samplesize, double *tempXdata, 
			   double *Xdata, double *tempterm,double *tempYdata,double *Ydata)
{
  int size,sumpower,singlepj,d,m;
  double carrot;

  for(m=0;m<samplesize;m++)
    {
      *(tempYdata+m) = *(Ydata+m);
      *(tempXdata+m*(maxsize+1))=1;
    }

  for(size=0;size<msize;size++)
    {
      sumpower=DSA_PACK_rowsumints(tempmodel,maxsize,nvarX,size);

      /*Just a main term */
      if(sumpower==1)
	{  
	  for(d=0;d<nvarX;d++)
	    {
	      singlepj = tempmodel[d*maxsize+size];
	      if(singlepj == 1)
		{
		  for(m=0;m<samplesize;m++)tempXdata[m*(maxsize+1)+size+1] = Xdata[m*nvarX+d];
		  break;
		}
	    }
	}

      /*Interactions or main term to the power>1*/
      if(sumpower > 1)
	{
	  for(m=0;m<samplesize;m++)tempterm[m] = 1.0;
	  for(d=0;d<nvarX;d++)
	    {
	      singlepj = tempmodel[d*maxsize+size];
	      if(singlepj > 1)
		{
		  for(m=0;m<samplesize;m++)
		    {
		      carrot = R_pow_di(Xdata[m*nvarX+d],singlepj);
		      tempterm[m] = tempterm[m] * carrot;
		    }
		}
	      if(singlepj == 1)for(m=0;m<samplesize;m++)tempterm[m] = tempterm[m] * Xdata[m*nvarX+d];
	    }
	  for(m=0;m<samplesize;m++)tempXdata[m*(maxsize+1)+size+1] = tempterm[m];
	}
    }

}


void DSA_PACK_evaluatenewmodel(int *sx,int maxsize,int msize,int *tempmodel,int newterm_index,
			       int *changeindexset,int nvarX, int samplesize,double *tempXdata,double *Xdata,
			       double *tempterm, int CENSOR,double *glmWT,double *WTdata, int IP,
			       double *tempYdata, double *Ydata,double *PARA,double *SE,double *COV,double *RES,
			       int *nglmcall,double *newrss,int *nextmodel,int inddel, int binind,
			       double* new_coefficients, double* WX, double* Z, double* qraux, double* effects,
			       double* work, int* pivot,double *binWTdata)
{
  int i,j,k,TDQ,IRANK = IP,NnonNA,MAXITER,PRINTITER;
  double DEV = 0.0,IDF,TOL,temprss;
  int fail = DSA_MODEL_NO_ERROR;
 

  /* Formulate new model */
  DSA_PACK_initialize_l(sx,maxsize+1);
  for(i=0;i<msize+1;i++)sx[i] = 1;
  if(inddel==0)for(i=0;i<nvarX;i++)tempmodel[i*maxsize+newterm_index] = changeindexset[i];
  else 
    {
      k = 0;
      for(i=0;i<maxsize;i++)if(i != newterm_index)
	{
	  for(j=0;j<nvarX;j++)tempmodel[j*maxsize+k] = changeindexset[j*maxsize+i];
	  k++;
	}
    }

  /* Print model tried on stdout */
  if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)
    {
      Rprintf("\nModel tried %li:",*nglmcall+1);
      Rprintf("\n");
      for(i=0;i<msize;i++)
	{
	  Rprintf("%ld \t ",i);
	  for(j=0;j<nvarX;j++)if(tempmodel[j*maxsize+i] > 0)Rprintf("%ld^%ld ",j,tempmodel[j*maxsize+i]);
	  Rprintf("\n");
	}
      /* DSA_PACK_printmatrixl(tempmodel,maxsize,nvarX); */
    }

  /* Form tempXdata,tempYdata and glmWT */
  DSA_PACK_gettempXdata(msize,tempmodel,maxsize,nvarX,samplesize,tempXdata,Xdata,tempterm,tempYdata,Ydata);
  DSA_PACK_getglmWT_excludeNA(samplesize,glmWT,tempXdata,tempYdata,msize,maxsize,&NnonNA,CENSOR,WTdata);

  /* Fit model */
  if(binind==1) {
    TOL=GLOBALg02tol;	
    for(i=0;i<samplesize;i++)*(RES+i)=1;
    TDQ=IP+6;
    MAXITER=25;
    PRINTITER=0;

    dsa_fit_lr(tempXdata, samplesize, maxsize + 1, IP, tempYdata, 
	       TOL, PARA, RES, effects, &IRANK, pivot, qraux, 
	       work, &DEV, glmWT, 25, new_coefficients, WX, 
	       Z, 0, &fail);
    
    if(IRANK < IP) {
      if(DSA_PACK_userMlevel >= DSA_PACK_Mhigh)
	Rprintf("\nModel ignored because not of full rank.");
      DEV = R_PosInf;
    }
    else {
      if (fail != DSA_MODEL_NO_ERROR) {
	if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)
	  Rprintf("\nAn error occured in run_lr");
	    
	if(fail == DSA_MODEL_ERROR_AT_BOUNDARY) {
	  DEV = R_PosInf;
	      
	  if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh) {
	    Rprintf("\nModel ignored (a fitted value is at a boundary) - rss set to infinity for:\n");
	    for(i=0;i<msize;i++) {
	      Rprintf("%ld \t ",i);
	      for(j=0;j<nvarX;j++)
		if(tempmodel[j*maxsize+i] > 0)
		  Rprintf("%ld^%ld ",j,tempmodel[j*maxsize+i]);
	      Rprintf("\n");
	    }
	  }
	}
	else if (fail == DSA_MODEL_ERROR_RANK_CHANGE) {
	  DEV = R_PosInf;

	  if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh) {
	    Rprintf("\nModel ignored (change in model rank) - rss set to infinity for:\n");
	    for(i=0;i<msize;i++) {
	      Rprintf("%ld \t ",i);
	      for(j=0;j<nvarX;j++)if(tempmodel[j*maxsize+i] > 0)
		Rprintf("%ld^%ld ",j,tempmodel[j*maxsize+i]);
	      Rprintf("\n");
	    }
	  }
	}
	else if (fail == DSA_MODEL_ERROR_NO_CONVERGENCE) {
	  DEV = R_PosInf;

	  if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh) {
	    Rprintf("\nModel ignored (no convergence) - rss set to infinity for:\n");
	    for(i=0;i<msize;i++) {
	      Rprintf("%ld \t ",i);
	      for(j=0;j<nvarX;j++)
		if(tempmodel[j*maxsize+i] > 0)
		  Rprintf("%ld^%ld ",j,tempmodel[j*maxsize+i]);
	      Rprintf("\n");
	    }
	  }
	}
	else {
	  Rprintf("Witnessed unknown error, ignoring model. fail code is: %d\n", fail);
	  DEV = R_PosInf; 
	  /* error("\n Fatal error. Aborting C subroutine."); */
	}
      }
      else {
	DEV=DSA_PACK_getarss(samplesize,tempXdata,maxsize,msize+1,tempYdata,glmWT,PARA,2,binWTdata);
      }
    }
    if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)
      Rprintf("\nDeviance: %lf - Rank: %li", DEV, IRANK);
   
  }
  else {
    TOL=GLOBALg02tol;	
    TDQ=IP+1;

    dsa_fit_mlr(tempXdata, samplesize, maxsize + 1, IP, tempYdata, glmWT, 
		TOL, PARA, RES, effects, &IRANK, pivot, qraux, work, &DEV, 0, &fail);

    if(IRANK < IP) {
      if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh) {
	Rprintf("\nModel ignored because the covariate matrix is not of full rank. ");
      }
      DEV=R_PosInf;
    }
        
    if(DSA_PACK_userMlevel >= DSA_PACK_Mhigh)
      Rprintf("\nResiduals sum of squares (weighted): %lf", DEV);
  }
  
  (*nglmcall)++;
  temprss = DEV/NnonNA;
  
  if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh) {
    Rprintf("\nCoefficients for model with ARSS of %lf based on NnonNA=%li obs: ",temprss,NnonNA);
    DSA_PACK_printmatrix(PARA,1,IP);
    Rprintf("\n");
  }

  /* Evaluate new model */
  if((*newrss - temprss)>epsiloncompare) {
    (*newrss) = temprss;
    for(i=0;i<maxsize;i++)
      for(j=0;j<nvarX;j++)nextmodel[j*maxsize+i] = tempmodel[j*maxsize+i];
  }
}


void DSA_PACK_checknewterm(int *orderint_in_newterm,int *sumofpow_in_newterm,int *is_newterm_unique,
			   int *newterm,int nvarX,int *tempmodel,int *ithterm,int maxsize,
			   int newterm_index,int addmove_notsubmove)
{
  *orderint_in_newterm = DSA_PACK_num_nonzero(newterm,nvarX);
  *sumofpow_in_newterm = DSA_PACK_sumofints(newterm,nvarX);

  /* check whether the new term is unique */
  *is_newterm_unique = DSA_PACK_istermunique(newterm,tempmodel,ithterm,maxsize,nvarX,newterm_index,
					     addmove_notsubmove,*orderint_in_newterm,*sumofpow_in_newterm);
}

int DSA_PACK_istermunique(int *newterm,int *tempmodel,int *ithterm,int maxsize,int nvarX,
			  int newterm_index,int addmove_notsubmove,int orderint_in_newterm, 
			  int sumofpow_in_newterm)
{
  int j,ithtermindex,orderint_in_ithterm,sumofpow_in_ithterm,ithterm_equal_newterm,k,uniqueind;

  uniqueind = 1;
  for(ithtermindex=0;ithtermindex<maxsize;ithtermindex++)
    {
      if((addmove_notsubmove == 1) || (addmove_notsubmove == 0 && ithtermindex != newterm_index))
	{	 
	  for(j=0;j<nvarX;j++)ithterm[j] = tempmodel[j*maxsize+ithtermindex];
	  orderint_in_ithterm = DSA_PACK_num_nonzero(ithterm,nvarX);
	  sumofpow_in_ithterm = DSA_PACK_sumofints(ithterm,nvarX);
	  if(orderint_in_newterm == orderint_in_ithterm && sumofpow_in_newterm == sumofpow_in_ithterm)
	    {
	      ithterm_equal_newterm=1;
	      for(j=0;j<nvarX;j++)
		{
		  if(newterm[j] == ithterm[j])k=1;
		  else k=0;
		  ithterm_equal_newterm*=k;
		}
	      if(ithterm_equal_newterm == 1)uniqueind=0;
	    }
	  if(uniqueind==0)break;
	}
    }
  return(uniqueind);
}


int DSA_PACK_exportresult(double *oldrss,double newrss,int msize,int nvarX,int *currentmodel,
			  int *nextmodel,int maxsize,double *bestarss,int *gCOUNT,int IP,
			  int nglmcall,int **bestmodels,int delind,double *currentarss)
{
  int sflag;
  int i,j;

  sflag=0;
  if(newrss==R_PosInf)
    {
      if(DSA_PACK_userMlevel>=DSA_PACK_Mhigh)
	Rprintf("\nNone of the candidate models in this step can be fitted.\n");
    }
  else
    {
      if((*oldrss - newrss)>epsiloncompare)
	{
	  sflag = 1;
	  (*oldrss) = newrss;
	  for(i=0;i<maxsize;i++)for(j=0;j<nvarX;j++)currentmodel[j*maxsize+i] = nextmodel[j*maxsize+i];

	  currentarss[IP-1]=*oldrss;
	  if(delind==1)
	    {
	      bestarss[IP-1]=currentarss[IP-1];
	      DSA_PACK_initialize_l(bestmodels[IP-2],maxsize*nvarX);
	      for(i=0;i<maxsize;i++)
		for(j=0;j<nvarX;j++)
		  bestmodels[IP-2][j*maxsize+i] = currentmodel[j*maxsize+i];
	      if(DSA_PACK_userMlevel>=DSA_PACK_Mmedium)
		{
		  Rprintf("\nModel accepted %li - bestarss: %lf\n",nglmcall,bestarss[IP-1]);
		  
		  
		  for(i=0;i<msize;i++)
		    {
		      Rprintf("%ld \t ",i);
		      for(j=0;j<nvarX;j++)
			if(bestmodels[IP-2][j*maxsize+i] > 0)
			  Rprintf("%ld^%ld ",j,bestmodels[IP-2][j*maxsize+i]);
		      Rprintf("\n");
		    }
		}
	    }
	}

      gCOUNT[0] = msize;
      gCOUNT[2] = nglmcall;

      /* Update Best Index Set */
      if((delind==0) && ( (bestarss[IP-1]-currentarss[IP-1])>epsiloncompare))
	{
	  bestarss[IP-1]=currentarss[IP-1];
	  DSA_PACK_initialize_l(bestmodels[IP-2],maxsize*nvarX);
	  for(i=0;i<maxsize;i++)for(j=0;j<nvarX;j++)bestmodels[IP-2][j*maxsize+i] = currentmodel[j*maxsize+i];
	  if(DSA_PACK_userMlevel>=DSA_PACK_Mmedium)
	    {
	      Rprintf("\nModel accepted %li - bestarss: %lf\n",nglmcall,bestarss[IP-1]);
	      for(i=0;i<msize;i++)
		{
		  Rprintf("%ld \t ",i);
		  for(j=0;j<nvarX;j++)if(bestmodels[IP-2][j*maxsize+i] > 0)
		    Rprintf("%ld^%ld ",j,bestmodels[IP-2][j*maxsize+i]);
		  Rprintf("\n");
		}
	    }
	}
    }
  return(sflag);
}

void  DSA_PACK_getglmWT_excludeNA(int samplesize,double *glmWT,double *tempXdata,double *tempYdata,
				  int msize,int maxsize,int *NnonNA,int CENSOR,double *WTdata)
{
  int i,j,onevarmissing;

  (*NnonNA)=samplesize;
  for(i=0;i<samplesize;i++)
    {
      onevarmissing=0;
      if(CENSOR==0)glmWT[i]=1;
      else 
	{
	  glmWT[i]=WTdata[i];
	  if(ISNA(*(glmWT+i))!=0)
	    {
	      *(glmWT+i)=0;
	      onevarmissing=1;
	    }
	}
      if(ISNA(*(tempYdata+i))!=0)
	{
	  *(glmWT+i)=0;
	  *(tempYdata+i)=0;
	  onevarmissing=1;
	}
      for(j=1;j<msize+1;j++)if(ISNA(*(tempXdata+j+i*(maxsize+1)))!=0)
	{
	  *(glmWT+i)=0;
	  *(tempXdata+j+i*(maxsize+1))=0;
	  onevarmissing=1;
	}
      if(onevarmissing==1)(*NnonNA)--;
    }

}

double DSA_PACK_getarss(int nobs,double *X,int nrow,int ncoef,double *Y,double *Weight,double *beta,int link,double *binWTdata)
{
  double temp,rss;
  int i,j;

  rss=0;
  for(i=0;i<nobs;i++)
    {
      temp=0;
      for(j=0;j<ncoef;j++)
	temp+=*(beta+j)**(X+j+i*(nrow+1));
      
      if(link==1)
	temp=*(Y+i)-temp;
      else if (link==2)
	temp=*(Y+i)-1/(1+exp(-temp));
     
      rss+=(*(Weight+i)**(binWTdata+i)*temp*temp);
    }
  return(rss);
}
